Index: /trunk/src/org/expeditee/items/Item.java
===================================================================
--- /trunk/src/org/expeditee/items/Item.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/Item.java	(revision 1102)
@@ -2419,6 +2616,6 @@
 	 * @param g
 	 */
-	protected void paintLink(Graphics2D g) {
-		paintLinkGraphic(g, getX() - LEFT_MARGIN, getY() + getLinkYOffset());
+	protected void paintLink() {
+		paintLinkGraphic(getX() - LEFT_MARGIN, getY() + getLinkYOffset());
 	}
 
@@ -2438,45 +2635,46 @@
 	 *            centered)
 	 */
-	public void paintLinkGraphic(Graphics2D g, int x, int y) {
-
-		boolean hasLink = getLink() != null;
+	public void paintLinkGraphic(int x, int y) {
+
+		boolean hasLink = hasLink();
 		boolean hasAction = hasAction();
 
 		if (hasLink || hasAction) {
-			g.setStroke(HIGHLIGHT_STROKE);
+			GraphicsManager g = EcosystemManager.getGraphicsManager();
+			Fill fill = new Fill();
+			Colour colour = null;
+			Point offset = new Point(x, y);
+			
 			if (hasLink && hasAction) {
-				g.setColor(LINK_ACTION_COLOR);
+				colour = LINK_ACTION_COLOR;
 			} else if (hasLink) {
-				g.setColor(LINK_COLOR);
+				colour = LINK_COLOR;
 			} else if (hasAction) {
-				g.setColor(ACTION_COLOR);
+				colour = ACTION_COLOR;
 			}
-
-			AffineTransform at = new AffineTransform();
-			AffineTransform orig = g.getTransform();
-			at.translate(x, y);
-			g.setTransform(at);
-
-			if (getLinkMark() && getLink() != null) {
-				g.drawPolygon(getLinkPoly());
-
+			fill.setColour(colour);
+
+			// Small circles look rubbish without AA. cts16
+			g.setAntialiasing(true);
+			
+			if (hasLink && getLinkMark()) {
+				g.drawOval(offset, getLinkBounds().getDiameters(), 0.0f, null, colour, HIGHLIGHT_STROKE);
+				
 				// if the link is not valid, cross out the circle
-				if (!isLinkValid())
-					g.drawPolygon(getCircleCross());
+				if (!isLinkValid()) {
+					g.drawPolygon(getCircleCross(), offset, null, 0.0f, null, colour, HIGHLIGHT_STROKE);
+				}
 			}
 
-			if (getActionMark() && hasAction()) {
-				g.drawPolygon(getLinkPoly());
-				g.fillPolygon(getLinkPoly());
+			if (hasAction && getActionMark()) {
+				g.drawOval(offset, getLinkBounds().getDiameters(), 0.0f, fill, colour, HIGHLIGHT_STROKE);
 
 				// if the link is not valid, cross out the circle
 				if (!isLinkValid() && getLink() != null) {
-					g.setColor(getParent().getPaintBackgroundColor());
-					g.drawPolygon(getCircleCross());
+					g.drawPolygon(getCircleCross(), offset, null, 0.0f, null, getParent().getPaintBackgroundColor(), HIGHLIGHT_STROKE);
 				}
 			}
-
-			// reset the graphics tranformation
-			g.setTransform(orig);
+			
+			g.setAntialiasing(false);
 		}
 	}
@@ -2539,5 +2737,5 @@
 			return null;
 		// assert (_parent!= null);
-		Frame parent = DisplayIO.getCurrentFrame();
+		Frame parent = DisplayController.getCurrentFrame();
 		assert (parent != null);
 
@@ -2587,9 +2785,9 @@
 		while (!lines.isEmpty()) {
 			Line l = lines.remove();
-			// if we havnt visited the line yet visit it
+			// if we haven't visited the line yet visit it
 			if (!visited.contains(l)) {
 				visited.add(l);
 				Item otherEnd = l.getOppositeEnd(this);
-				// Add all the enexplored lines to our list
+				// Add all the unexplored lines to our list
 				while (!lines.isEmpty()) {
 					l = lines.remove();
@@ -2613,33 +2811,61 @@
 	 *         is part of
 	 */
-	public double getEnclosedArea() {
-		if (_enclosure == null)
-			return 0.0;
-		Rectangle2D box = getEnclosedShape().getBounds2D();
+	public double getEnclosedArea()
+	{
+		AxisAlignedBoxBounds box = getEnclosedBox();
+		if (box == null) return 0.0;
 		return box.getWidth() * box.getHeight();
 	}
 
-	public Rectangle getEnclosedRectangle() {
-		if (_enclosure == null)
-			return null;
-		return getEnclosedShape().getBounds();
-	}
-
-	public int getEnclosureID() {
+	/**
+	 * Gets the box encompassing all points that form an enclosure with this item.
+	 * 
+	 * @return An axis-aligned box around all enclosure points.
+	 */
+	public AxisAlignedBoxBounds getEnclosedBox()
+	{
+		if (_enclosure == null) return null;
+		
+		return AxisAlignedBoxBounds.getEnclosing(getEnclosedShape());
+	}
+
+	public int getEnclosureID()
+	{
 		return _enclosure == null ? 0 : _enclosure.hashCode();
 	}
 
 	/**
-	 * Returns the Shape that surrounds this Item representing this Item's
+	 * Returns the Bounds that surrounds this Item representing this Item's
 	 * 'gravity'.
 	 * 
-	 * @return The Shape (rectangle) surrounding this Item, which represents
+	 * @return The Bounds surrounding this Item, which represents
 	 *         this Items 'gravity'.
 	 */
-	public final Polygon getPolygon() {
-		if (_poly == null)
-			updatePolygon();
-
-		return new Polygon(_poly.xpoints, _poly.ypoints, _poly.npoints);
+	public final Bounds getBounds()
+	{
+		if (_bounds == null) _bounds = updateBounds();
+		
+		// DEBUG
+		if (_bounds == null) {
+			//System.out.println("updateBounds failed!");
+		}
+
+		return _bounds;
+	}
+	
+	public final Bounds getOldBounds()
+	{
+		return _oldBounds;
+	}
+	
+	public final void invalidateBounds()
+	{
+		if (_bounds != null) _oldBounds = _bounds;
+		_bounds = null;
+	}
+	
+	public final AxisAlignedBoxBounds getBoundingBox()
+	{
+		return AxisAlignedBoxBounds.getEnclosing(getBounds());
 	}
 
@@ -2651,13 +2877,13 @@
 	 * @param ratio
 	 */
-	public void translate(Point2D origin, double ratio) {
+	public void translate(Point origin, double ratio) {
 
 		invalidateCommonTraitForAll(ItemAppearence.PreMoved);
 
-		_x = (float) (origin.getX() + ratio * (_x - origin.getX()));
-		_y = (float) (origin.getY() + ratio * (_y - origin.getY()));
-		updatePolygon();
+		_x = (float) (origin.x + ratio * (_x - origin.x));
+		_y = (float) (origin.y + ratio * (_y - origin.y));
+		invalidateBounds();
 		for (Line line : getLines())
-			line.updatePolygon();
+			line.invalidateBounds();
 
 		invalidateCommonTraitForAll(ItemAppearence.PostMoved);
@@ -2698,14 +2924,4 @@
 	}
 
-	Collection<XRayable> _enclosures = new HashSet<XRayable>();
-
-	private boolean _deleted = false;
-
-	private Overlay _overlay = null;
-
-	protected AttributeValuePair _attributeValuePair = null;
-
-	private Float _autoStamp = null;
-
 	/**
 	 * For now there can only be one enclosure per item
@@ -2741,10 +2957,10 @@
 	 *         highlighting bounds
 	 */
-	public Rectangle[] getDrawingArea() {
-
-		return new Rectangle[] { ItemUtils.expandRectangle(getPolygon()
-				.getBounds(), (int) Math.ceil(Math.max(_highlightThickness,
-				getThickness()))) };
-
+	public AxisAlignedBoxBounds getDrawingArea() {
+
+		return ItemUtils.expandRectangle(
+					getBoundingBox(),
+					(int) Math.ceil(Math.max(_highlightThickness, getThickness())) + 1 // + 1 to make sure
+		);
 	}
 
@@ -2754,17 +2970,19 @@
 	 * @return True if area intersects with this items drawing area.
 	 */
-	public final boolean isInDrawingArea(Area area) {
-		for (Rectangle r : getDrawingArea()) {
-			if (area.intersects(r))
-				return true;
-		}
-		return false;
-	}
-
-	/**
-	 * Completetly invalidates the item - so that it should be redrawed. Note:
-	 * This is handled internally, it should be reare to invoke this externally
-	 */
-	public final void invalidateAll() {
+	public final boolean isInDrawingArea(AxisAlignedBoxBounds area)
+	{
+		AxisAlignedBoxBounds drawingArea = getDrawingArea();
+		
+		if (drawingArea == null) return false;
+		
+		return drawingArea.intersects(area);
+	}
+
+	/**
+	 * Completely invalidates the item - so that it should be redrawn. Note:
+	 * This is handled internally, it should be rare to invoke this externally
+	 */
+	public final void invalidateAll()
+	{
 		invalidate(getDrawingArea());
 	}
@@ -2776,7 +2994,7 @@
 	 * @param damagedAreas
 	 */
-	protected final void invalidate(Rectangle[] damagedAreas) {
-		for (Rectangle r : damagedAreas)
-			invalidate(r);
+	protected final void invalidate(Bounds[] damagedAreas)
+	{
+		if (damagedAreas != null) for (Bounds b : damagedAreas) invalidate(b);
 	}
 
@@ -2787,6 +3005,7 @@
 	 * @param damagedAreas
 	 */
-	protected final void invalidate(Rectangle damagedArea) {
-		FrameGraphics.invalidateItem(this, damagedArea);
+	protected final void invalidate(Bounds damagedArea)
+	{
+		if (damagedArea != null) DisplayController.invalidateItem(this, damagedArea);
 	}
 
@@ -2796,9 +3015,9 @@
 	 * @param trait
 	 */
-	public final void invalidateCommonTrait(ItemAppearence trait) {
+	public final void invalidateCommonTrait(ItemAppearence trait)
+	{
 		invalidate(getDamagedArea(trait));
 
-		if (_colorFill != null
-				&& (trait == ItemAppearence.Added || trait == ItemAppearence.Removed)) {
+		if (_fillColour != null && (trait == ItemAppearence.Added || trait == ItemAppearence.Removed)) {
 			invalidateFill();
 		}
@@ -2808,7 +3027,8 @@
 	 * Invalidates fill if has one, even if no color is set.
 	 */
-	public void invalidateFill() {
+	public void invalidateFill()
+	{
 		if (isLineEnd() && _enclosure != null) {
-			invalidate(getEnclosedShape().getBounds());
+			invalidate(getEnclosedBox());
 		}
 	}
@@ -2826,13 +3046,10 @@
 	 * @return The damaged area according to the visual trait that has changed.
 	 */
-	protected Rectangle[] getDamagedArea(ItemAppearence trait) {
-
+	protected AxisAlignedBoxBounds getDamagedArea(ItemAppearence trait)
+	{
 		if (trait == ItemAppearence.LinkChanged)
-			return new Rectangle[] { getLinkDrawArea() }; // Invalidate area
-		// where link is
-		// drawn
+			return getLinkDrawArea(); // Invalidate area where link is drawn
 
 		return getDrawingArea();
-
 	}
 
@@ -2864,7 +3081,7 @@
 	}
 
-	public void setAnchorLeft(Float anchor) {
-		this._anchorLeft = anchor;
-		this._anchorRight = null;
+	public void setAnchorLeft(Integer anchor)
+	{
+		this._anchoring.setLeftAnchor(anchor);
 		if (anchor != null) {
 			anchorConstraints();
@@ -2873,17 +3090,16 @@
 	}
 
-	public void setAnchorRight(Float anchor) {
-		this._anchorRight = anchor;
-		this._anchorLeft = null;
+	public void setAnchorRight(Integer anchor)
+	{
+		this._anchoring.setRightAnchor(anchor);
 		if (anchor != null) {
 			anchorConstraints();
-			setX(FrameGraphics.getMaxFrameSize().width - anchor
-					- getBoundsWidth());
-		}
-	}
-
-	public void setAnchorTop(Float anchor) {
-		this._anchorTop = anchor;
-		this._anchorBottom = null;
+			setX(DisplayController.getFramePaintArea().getMaxX() - anchor - getBoundsWidth());
+		}
+	}
+
+	public void setAnchorTop(Integer anchor)
+	{
+		this._anchoring.setTopAnchor(anchor);
 		if (anchor != null) {
 			anchorConstraints();
@@ -2893,41 +3109,40 @@
 
 
-	public void setAnchorBottom(Float anchor) {
-		this._anchorBottom = anchor;
-		this._anchorTop = null;
+	public void setAnchorBottom(Integer anchor)
+	{
+		this._anchoring.setBottomAnchor(anchor);
 		if (anchor != null) {
 			anchorConstraints();
-			setY(FrameGraphics.getMaxFrameSize().height - anchor);
-		}
-	}
-
-
-	public boolean isAnchored() {
-	    return ((_anchorLeft != null) || (_anchorRight != null) 
-		    || (_anchorTop != null) || (_anchorBottom != null));
+			setY(DisplayController.getFramePaintArea().getMaxY() - anchor);
+		}
+	}
+
+	public boolean isAnchored()
+	{
+	    return _anchoring.isAnchored();
 	}
 
 	public boolean isAnchoredX() {
-	    return ((_anchorLeft != null) || (_anchorRight != null));
+	    return _anchoring.isXAnchored();
 	}
 
 	public boolean isAnchoredY() {
-	    return ((_anchorTop != null) || (_anchorBottom != null));
-	}
-
-	public Float getAnchorLeft() {
-		return _anchorLeft;
-	}
-
-	public Float getAnchorRight() {
-		return _anchorRight;
-	}
-
-	public Float getAnchorTop() {
-		return _anchorTop;
-	}
-
-	public Float getAnchorBottom() {
-		return _anchorBottom;
+	    return _anchoring.isYAnchored();
+	}
+
+	public Integer getAnchorLeft() {
+		return _anchoring.getLeftAnchor();
+	}
+
+	public Integer getAnchorRight() {
+		return _anchoring.getRightAnchor();
+	}
+
+	public Integer getAnchorTop() {
+		return _anchoring.getTopAnchor();
+	}
+
+	public Integer getAnchorBottom() {
+		return _anchoring.getBottomAnchor();
 	}
 
@@ -3024,10 +3239,9 @@
 		// Invalidate them again!!
 		for (Item i : this.getAllConnected()) {
-			i.updatePolygon();
+			i.invalidateBounds();
 			i.invalidateAll();
 		}
 	}
 
-	
 	protected void anchorConnected(AnchorEdgeType anchorEdgeType, Float delta) {
 		
@@ -3087,5 +3301,5 @@
 		// Invalidate them again!!
 		for (Item i : this.getAllConnected()) {
-			i.updatePolygon();
+			i.invalidateBounds();
 			i.invalidateAll();
 		}
@@ -3123,5 +3337,5 @@
 		// DONT PUT SIZE IN HERE CAUSE IT STUFFS UP CIRCLES
 
-		updatePolygon();
+		invalidateBounds();
 	}
 
@@ -3168,29 +3382,4 @@
 		return _autoStamp != null && _autoStamp >= 0.0;
 	}
-
-	public void setDotType(DotType type) {
-		invalidateAll();
-		_type = type;
-		invalidateAll();
-	}
-
-	public DotType getDotType() {
-		return _type;
-	}
-
-	public void setFilled(boolean filled) {
-		invalidateAll();
-		_filled = filled;
-		invalidateAll();
-	}
-
-	public boolean getFilled() {
-		return _filled;
-	}
-		
-	private Item _magnetizedItemLeft = null;
-	private Item _magnetizedItemRight = null;
-	private Item _magnetizedItemTop = null;
-	private Item _magnetizedItemBottom = null;
 	
 	public int getMagnetizedItemLeft() {
@@ -3245,3 +3434,54 @@
 		setMagnetizedItemBottom(this.getParent().getItemWithID(id));
 	}
+
+	/**
+	 * Replaces the given dot item with a text item displaying the given character.
+	 * 
+	 * @param dot
+	 * 		The Dot item to replace.
+	 * 
+	 * @param ch
+	 * 		The character to display as the text for the created Text item.
+	 * 
+	 * @return
+	 * 		The created Text item.
+	 */
+	public static Text replaceDot(Item dot, char ch) {
+		// TODO: Should this make sure 'dot' is actually a Dot and not some other item? cts16
+		Text text = Text.createText(ch);
+		Item.DuplicateItem(dot, text);
+		FrameUtils.setLastEdited(text);
+
+		// Copy the lines list so it can be modified
+		List<Line> lines = new LinkedList<Line>(dot.getLines());
+		for (Line line : lines)
+			line.replaceLineEnd(dot, text);
+		Frame current = dot.getParentOrCurrentFrame();
+		current.removeItem(dot);
+		ItemUtils.EnclosedCheck(current.getItems());
+		return text;
+		// TODO: Should this add the newly-created Text item to the frame? cts16
+	}
+
+	/**
+	 * Replaces the given text item with a dot
+	 */
+	public static Item replaceText(Item text) {
+		Item dot = new Dot(text.getX(), text.getY(), text.getID());
+		Item.DuplicateItem(text, dot);
+
+		List<Line> lines = new LinkedList<Line>();
+		lines.addAll(text.getLines());
+		if (lines.size() > 0)
+			dot.setColor(lines.get(0).getColor());
+		for (Line line : lines) {
+			line.replaceLineEnd(text, dot);
+		}
+		text.delete();
+		Frame current = text.getParentOrCurrentFrame();
+		current.addItem(dot);
+		DisplayController.setCursor(Item.DEFAULT_CURSOR);
+		ItemUtils.EnclosedCheck(current.getItems());
+		return dot;
+	}
 }
Index: /trunk/src/org/expeditee/items/ItemAppearence.java
===================================================================
--- /trunk/src/org/expeditee/items/ItemAppearence.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/ItemAppearence.java	(revision 1102)
@@ -20,5 +20,5 @@
 
 /**
- * Used for invlaidation on items.
+ * Used for invalidation on items.
  * @author Brook Novak
  */
@@ -37,4 +37,6 @@
 	Removed,
 	ToggleDashed,
-	Thickness, GradientColor, BorderColorChanged
+	Thickness,
+	GradientColor,
+	BorderColorChanged
 }
Index: /trunk/src/org/expeditee/items/ItemUtils.java
===================================================================
--- /trunk/src/org/expeditee/items/ItemUtils.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/ItemUtils.java	(revision 1102)
@@ -19,7 +19,4 @@
 package org.expeditee.items;
 
-import java.awt.Color;
-import java.awt.Rectangle;
-import java.awt.image.ImageObserver;
 import java.io.File;
 import java.io.UnsupportedEncodingException;
@@ -34,5 +31,8 @@
 import java.util.Map;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Colour;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gui.DisplayController;
+import org.expeditee.gui.DisplayController.TwinFramesSide;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameUtils;
@@ -40,5 +40,5 @@
 import org.expeditee.gui.Vector;
 import org.expeditee.items.Item.HighlightMode;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.InteractiveWidgetInitialisationFailedException;
 import org.expeditee.items.widgets.InteractiveWidgetNotAvailableException;
@@ -360,9 +360,9 @@
 	 * 
 	 * @param source
-	 *            The Text file containing the Picture infomation
+	 *            The Text file containing the Picture information
 	 * @return The Picture object representing the file, or Null if the file is
 	 *         not found.
 	 */
-	public static Picture CreatePicture(Text source, ImageObserver observer, boolean tryRemote) {
+	public static Picture CreatePicture(Text source, boolean tryRemote) {
 		String text = source.getText();
 		String path = "";
@@ -424,5 +424,5 @@
        				// call CreatePicture again, but with tryRemote set to false so we won't get into an infinite loop
        				// if something goes wrong with finding the downloaded image
-       				return CreatePicture(source, observer, false);
+       				return CreatePicture(source, false);
        			}
 				return null;
@@ -434,5 +434,5 @@
 
 		try {
-			Picture pic = new Picture(source, fileName, path, size, observer);
+			Picture pic = new Picture(source, fileName, path, size);
 
 			return pic;
@@ -444,6 +444,6 @@
 	}
 	
-	public static Picture CreatePicture(Text source, ImageObserver observer) {
-		return CreatePicture(source, observer, true);
+	public static Picture CreatePicture(Text source) {
+		return CreatePicture(source, true);
 	}
 
@@ -483,5 +483,5 @@
 
 		// Widgets are super special
-		List<InteractiveWidget> widgets = new ArrayList<InteractiveWidget>();
+		List<Widget> widgets = new ArrayList<Widget>();
 
 		for (Item i : toCopy) {
@@ -596,5 +596,5 @@
 			Item start = lineEndMap.get(c.getStart());
 			Item end = lineEndMap.get(c.getEnd());
-			int id = DisplayIO.getCurrentFrame().getNextItemID();
+			int id = DisplayController.getCurrentFrame().getNextItemID();
 			if (start != null && end != null) {
 				new Constraint(start, end, id, c.getType());
@@ -603,8 +603,8 @@
 
 		// BROOK
-		for (InteractiveWidget iw : widgets) {
+		for (Widget iw : widgets) {
 			try {
 
-				InteractiveWidget icopy = iw.copy();
+				Widget icopy = iw.copy();
 				copies.addAll(icopy.getItems());
 
@@ -680,4 +680,5 @@
 		Item copy = origEnd.copy();
 		origEnd.setHighlightMode(HighlightMode.None);
+		origEnd.setHighlightColorToDefault();
 		copy.removeAllLines();
 		copy.removeAllConstraints();
@@ -688,5 +689,5 @@
 
 		// create a new line
-		Frame currentFrame = DisplayIO.getCurrentFrame();
+		Frame currentFrame = DisplayController.getCurrentFrame();
 		Line line = new Line(origEnd, copy, currentFrame.getNextItemID());
 		// if the previous line was constrained then make the new line
@@ -694,6 +695,5 @@
 		// TODO add later a diagonal constraint if getLines() == 3 or 4
 		Collection<Constraint> constraints = origEnd.getConstraints();
-		if (constrain && constraints.size() > 0
-				&& origEnd.getLines().size() == 2) {
+		if (constrain && constraints.size() > 0 && origEnd.getLines().size() == 2) {
 			Integer type = null;
 			for (Constraint c : constraints) {
@@ -710,6 +710,5 @@
 			}
 			if (type != null) {
-				new Constraint(origEnd, copy, currentFrame.getNextItemID(),
-						type);
+				new Constraint(origEnd, copy, currentFrame.getNextItemID(), type);
 			}
 		}
@@ -726,9 +725,9 @@
 
 	public static void New() {
-		EnclosedCheck(DisplayIO.getCurrentFrame().getItems());
+		EnclosedCheck(DisplayController.getCurrentFrame().getItems());
 	}
 
 	public static void Old() {
-		OldEnclosedCheck(DisplayIO.getCurrentFrame().getItems());
+		OldEnclosedCheck(DisplayController.getCurrentFrame().getItems());
 	}
 
@@ -902,12 +901,12 @@
 	 */
 	public static boolean isVisible(Item i) {
-		if (DisplayIO.isTwinFramesOn()) {
-			if (!isVisible(DisplayIO.getFrames()[0], i)) {
-				return isVisible(DisplayIO.getFrames()[1], i);
+		if (DisplayController.isTwinFramesOn()) {
+			if (!isVisible(DisplayController.getFrameOnSide(TwinFramesSide.LEFT), i)) {
+				return isVisible(DisplayController.getFrameOnSide(TwinFramesSide.RIGHT), i);
 			} else {
 				return true;
 			}
 		} else {
-			return isVisible(DisplayIO.getCurrentFrame(), i);
+			return isVisible(DisplayController.getCurrentFrame(), i);
 		}
 	}
@@ -923,23 +922,24 @@
 	 * @return True if visible/free from given frame.
 	 */
-	public static boolean isVisible(Frame fromFrame, Item i) {
-		if (fromFrame == null)
-			return false;
+	public static boolean isVisible(Frame fromFrame, Item i)
+	{
+		if (fromFrame == null) return false;
 
 		Frame parent = i.getParent();
 
-		if (parent == fromFrame)
+		if (parent == fromFrame) {
 			return true;
+		} else if (parent == null) {
+			return FreeItems.getInstance().contains(i) || FreeItems.getCursor().contains(i);
+		}
 		
-		else if (parent == null)
-			return FreeItems.getInstance().contains(i)
-					|| FreeItems.getCursor().contains(i);
-
 		return fromFrame.getAllItems().contains(i) && i.isVisible();
 	}
 
-	public static Rectangle expandRectangle(Rectangle r, int n) {
-		return new Rectangle(r.x - (n >> 1), r.y - (n >> 1), r.width + n,
-				r.height + n);
+	public static AxisAlignedBoxBounds expandRectangle(AxisAlignedBoxBounds r, int n)
+	{
+		if (r == null) return null;
+		
+		return new AxisAlignedBoxBounds(r.getMinX() - (n >> 1), r.getMinY() - (n >> 1), r.getWidth() + n, r.getHeight() + n);
 	}
 
@@ -973,6 +973,6 @@
 		int originX = v.Origin.x;
 		int originY = v.Origin.y;
-		Color defaultForeground = v.Foreground;
-		Color defaultBackground = v.Background;
+		Colour defaultForeground = v.Foreground;
+		Colour defaultBackground = v.Background;
 		UserAppliedPermission permission = v.permission;
 		// TODO should this be checking if the frame has the
@@ -1014,8 +1014,8 @@
 	 * @return List of (unique)widgets in items. Never null.
 	 */
-	public static List<InteractiveWidget> extractWidgets(List<Item> items) {
+	public static List<Widget> extractWidgets(List<Item> items) {
 		assert (items != null);
 
-		List<InteractiveWidget> iWidgets = new LinkedList<InteractiveWidget>();
+		List<Widget> iWidgets = new LinkedList<Widget>();
 
 		for (Item i : items) {
@@ -1053,5 +1053,7 @@
 	 * @param frame
 	 */
-	public static void Justify(Frame frame) {
+	public static void Justify(Frame frame)
+	{
+		if (frame == null) return;
 		EnclosedCheck(frame.getItems());
 		Justify(frame.getItems());
Index: /trunk/src/org/expeditee/items/JSItem.java
===================================================================
--- /trunk/src/org/expeditee/items/JSItem.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/JSItem.java	(revision 1102)
@@ -19,6 +19,4 @@
 package org.expeditee.items;
 
-import java.awt.Graphics2D;
-import java.awt.Polygon;
 import java.util.LinkedList;
 import java.util.List;
@@ -29,6 +27,7 @@
 import javax.script.ScriptException;
 
-import org.expeditee.gui.DisplayIO;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.Util;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gui.DisplayController;
 
 public class JSItem extends XRayable implements JSThreadable {
@@ -64,6 +63,6 @@
     
 	private static Text getSauce(int width, int height) {
-		Text source = new Text(DisplayIO.getCurrentFrame().getNextItemID(), "@js: " + width + " " + height);
-		source.setParent(DisplayIO.getCurrentFrame());
+		Text source = new Text(DisplayController.getCurrentFrame().getNextItemID(), "@js: " + width + " " + height);
+		source.setParent(DisplayController.getCurrentFrame());
 		return source;
 	}
@@ -115,7 +114,9 @@
 
 	@Override
-	public void paint(Graphics2D g) {
-		try {
-	        this.invocable.invokeFunction("paint", (Object)g);
+	public void paint(/*Graphics2D g*/) {
+		try {
+			// Not sure of the consequences of changing this? cts16
+	        //this.invocable.invokeFunction("paint", (Object)g);
+			this.invocable.invokeFunction("paint");
         } catch (Exception e) {
 	        e.printStackTrace();
@@ -130,10 +131,7 @@
 
 	@Override
-	public void updatePolygon() {
-		_poly = new Polygon();
-		_poly.addPoint(getX(), getY());
-		_poly.addPoint(getX() + _width, getY());
-		_poly.addPoint(getX() + _width, getY() + _height);
-		_poly.addPoint(getX(), getY() + _height);
+	public AxisAlignedBoxBounds updateBounds()
+	{
+		return new AxisAlignedBoxBounds(getX(), getY(), _width, _height);
 	}
 	
@@ -158,5 +156,5 @@
 			return;
 		}
-		String[] args = InteractiveWidget.parseArgs(text.substring(index));
+		String[] args = Util.parseArgs(text.substring(index));
 		try {
 			this.scriptEngine.eval("load = " + this.load);
@@ -189,5 +187,5 @@
 		newText.append(_width).append(" ").append(_height);
 		
-		String stateArgs = InteractiveWidget.formatArgs(saveArgs());
+		String stateArgs = Util.formatArgs(saveArgs());
 		if (stateArgs != null) {
 			newText.append(':');
@@ -239,3 +237,9 @@
 	}
 
+	@Override
+	public float getSize() {
+		// TODO Auto-generated method stub
+		return 0;
+	}
+
 }
